Package org.apache.commons.io.comparator

# Class DefaultFileComparator

java.lang.Object
org.apache.commons.io.comparator.DefaultFileComparator

All Implemented Interfaces:
  `Serializable`, `Comparator<File>`

public class DefaultFileComparator extends Object implements Serializable
Compares two files using the default `File.compareTo(File)` method.

This comparator can be used to sort lists or arrays of files by using the default file comparison.

Example of sorting a list of files using the `DEFAULT_COMPARATOR` singleton instance:

           List<File> list = ...
           ((AbstractFileComparator) DefaultFileComparator.DEFAULT_COMPARATOR).sort(list);

Example of doing a reverse sort of an array of files using the `DEFAULT_REVERSE` singleton instance:

           File[] array = ...
           ((AbstractFileComparator) DefaultFileComparator.DEFAULT_REVERSE).sort(array);

## Deprecating Serialization

Serialization is deprecated and will be removed in 3.0.

Since:
  1.4
See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Comparator<File>`
  `DEFAULT_COMPARATOR`
  Singleton default comparator instance
  `static final Comparator<File>`
  `DEFAULT_REVERSE`
  Singleton reverse default comparator instance

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultFileComparator()`
  Constructs a new instance.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compare(File file1, File file2)`
  Compares the two files using the `File.compareTo(File)` method.
  `File[]`
  `sort(File... files)`
  Sorts an array of files.
  `List<File>`
  `sort(List<File> files)`
  Sorts a List of files.
  `String`
  `toString()`
  String representation of this file comparator.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Comparator

  `equals, reversed, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

- ## Field Details

  - ### DEFAULT_COMPARATOR

    public static final Comparator<File> DEFAULT_COMPARATOR
    Singleton default comparator instance

  - ### DEFAULT_REVERSE

    public static final Comparator<File> DEFAULT_REVERSE
    Singleton reverse default comparator instance

- ## Constructor Details

  - ### DefaultFileComparator

    public DefaultFileComparator()
    Constructs a new instance.

- ## Method Details

  - ### compare

    public int compare(File file1, File file2)
    Compares the two files using the `File.compareTo(File)` method.
    Specified by:
      `compare` in interface `Comparator<File>`
    Parameters:
      `file1` - The first file to compare
      `file2` - The second file to compare
    Returns:
      the result of calling file1's `File.compareTo(File)` with file2 as the parameter.

  - ### sort

    public File[] sort(File... files)
    Sorts an array of files.

    This method uses `Arrays.sort(Object[], Comparator)` and returns the original array.

    Parameters:
      `files` - The files to sort, may be null.
    Returns:
      The sorted array.
    Since:
      2.0

  - ### sort

    public List<File> sort(List<File> files)
    Sorts a List of files.

    This method uses `List.sort(Comparator)` and returns the original list.

    Parameters:
      `files` - The files to sort, may be null.
    Returns:
      The sorted list.
    Since:
      2.0

  - ### toString

    public String toString()
    String representation of this file comparator.
    Overrides:
      `toString` in class `Object`
    Returns:
      String representation of this file comparator.